local Zifnabs_release="r131004b" 
local Zifnabs_DefaultSettings = {
		["point"] = "CENTER",
		["relativePoint"] = "CENTER",
		["relativeTo"] = "UIParent",
		["offsetX"] = -400,
		["offsetY"] = 75,
		["visible"] = 1,
		["reloadui"] = 1,
		["button"]={[1]="hi",[2]="bye",[3]="danke"},
		["say"]={
			["hi"] = {
				["notarget"]={"Hallo zusammen","Seid mir gegrüßt, alle zusammen"},
				["any"]={"Hallo, %t","Sei mir gegrüßt, %t"},
				["male"]={"Schön, Dich zu sehen, %t"},
				["female"]={"Wie schön, Dich zu sehen, %t", "Sei mir gegrüßt, holde %t"},
			},
			["bye"]={
				["notarget"]={"Ciao","Auf Wiedersehen","Lebt wohl alle miteinander"},
				["any"]={"Auf Wiedersehen, %t","Lebewohl, %t", "Gute Wege, %t"},
				["male"]={"Mach's gut, %t"},
				["female"]={},
			},
			["danke"]={
					["notarget"]={"Danke","Vielen Dank"},
					["any"]={"Vielen Dank, %t", "Ich danke Euch, %t", "Seid bedankt, %t"},
					["female"]={},
					["male"]={},
			},
		},
}

local loaded=nil
local timer=0
local timer_action={}

function Zifnabs_OnLoad(this)
	zif_echo(Zifnabs_release.." wird geladen")
	this:RegisterEvent("SAVE_VARIABLES")
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("UNIT_TARGET_CHANGED")
	this:RegisterEvent("COMBATMETER_DAMAGE")
	this:RegisterEvent("LOADING_END")
	SaveVariables("Zifnabs_Settings")  -- settings are saved to this table
end

SLASH_Zifnabs1="/zif"
SlashCmdList["Zifnabs"]=function(editBox,command)
	zif_command(command)
end
function zif_command(command)
	local word1,parm=zif_parse(command)
	word1=string.lower(word1)
	local word2,parm2=zif_parse(parm)
	word2=string.lower(word2)
	if (word1=="hide" and parm=="") then	
		Zifnabs_Settings.visible=0
		timer_action={}
		zif_display()
		zif_echo("wird nicht mehr angezeigt. Anzeige wieder aktivieren mit /zif show")
	elseif (word1=="show" and parm=="") then
		Zifnabs_Settings.visible=1
		zif_display()
		zif_echo("wird angezeigt")
	elseif (word1=="hide" and string.lower(parm)=="rui") then
		Zifnabs_Settings.reloadui=0
		getglobal("Zifnabs_ReloadUI"):Hide()
		zif_echo("ReloadUI-Button wird nicht mehr angezeigt")
	elseif (word1=="show" and  string.lower(parm)=="rui") then
		Zifnabs_Settings.reloadui=1
		getglobal("Zifnabs_ReloadUI"):Show()
		zif_echo("ReloadUI-Button wird angezeigt")
	elseif (word1=="timer") then 
		zif_Timer_set(word2,"remind "..parm2)
		zif_echo("Timer gesetzt")
	elseif (word1=="do" and Zifnabs_Settings["say"][word2]) then
		zif_tell(word2)
	elseif (word1=="do") then
		zif_error("Button "..word2.." ist nicht definiert")
	elseif (word1=="list" and word2=="timers") then
		for t=1,#timer_action,1 do
			local delta=math.ceil(10*(timer_action[t]["timer"]-timer))/10
			zif_echo("in "..delta.."s : "..timer_action[t]["command"])
		end
	elseif (word1=="list" and word2=="buttons") then
		for button,table in pairs(Zifnabs_Settings["say"]) do
			zif_echo("Button "..button)
		end
	elseif (word1=="list" and Zifnabs_Settings["say"][word2]) then
		zif_echo("Liste für Button "..word2)
		for category,table in pairs(Zifnabs_Settings["say"][word2]) do
			zif_echo(category..":")
			for t=1,#table,1 do
				zif_echo(t..": "..table[t])
			end
		end
	elseif (word1=="list") then
		zif_error("Button "..word2.." ist nicht definiert")
	elseif (word1=="add" and Zifnabs_Settings["say"][word2]) then
		local category,text=zif_parse(parm2)
		local tbl=Zifnabs_Settings["say"][word2][category]
		if tbl then
			table.insert(tbl,text)
			zif_echo("Text zu "..word2..":"..category.." hinzugefügt")
			Zifnabs_Settings["say"][word2][category]=tbl
		else
			zif_error("Kategorie "..word2..":"..category.." ist undefiniert")
		end
	elseif (word1=="add") then
		zif_error("Button "..word2.." ist nicht definiert")
	elseif (word1=="del" and Zifnabs_Settings["say"][word2]) then
		if parm2=="" then
			local check=Zifnabs_Settings["button"]
			for number,text in pairs(check) do
				if text==word2 then
					table.remove(Zifnabs_Settings["button"],number)
				end
			end
			local newsay={}
			for button,table in pairs(Zifnabs_Settings["say"]) do
				if (button==word2) then
				else
					newsay[button]=Zifnabs_Settings["say"][button]
				end
			end
			Zifnabs_Settings["say"]=newsay
			zif_echo("Button "..word2.." gelöscht")
			zif_display()
		else
			local category,number=zif_parse(parm2)
			if not Zifnabs_Settings["say"][word2][category] then
				zif_error("Kategorie "..word2..":"..category.." ist nicht definiert")
			elseif not zifnabs_Settings["say"][word2][category][number] then
				zif_error("Text "..number.." in Kategorie "..word2..":"..category.." ist nicht definiert")
			else
				table.remove(Zifnabs_Settings["say"][word2][category],number)
				zif_echo("Nachricht "..number.." aus der Kategorie "..word2..":"..category.." gelöscht")
			end
		end
	elseif (word1=="del") then
		zif_error("Button "..word2.." ist nicht definiert")
	elseif (word1=="define" and word2=="") then
		zif_error("Keinen Namen für Button angegeben")
	elseif (word1=="define" and Zifnabs_Settings["say"][word2]) then
			zif_error("Kategorie "..word2.." ist bereits definiert")
	elseif (word1=="define") then
		local newcategory={["notarget"]={},["any"]={},["female"]={},["male"]={}}
		Zifnabs_Settings["say"][word2]=newcategory
		local bnr=0
		for i=1,99,1 do
			if bnr==0 and not Zifnabs_Settings["button"][i] then
				bnr=i
			end
		end
		table.insert(Zifnabs_Settings["button"],bnr,word2)
		zif_echo("Neuer Button "..word2.." erstellt")
		zif_display()
	else
		zif_error("unbekannter Befehl '"..word1.."'")
	end	
end

function Zifnabs_OnEvent(this, event)

	if ( event == "UNIT_TARGET_CHANGED" ) then
	elseif ( event == "COMBATMETER_DAMAGE" ) then
	elseif ( event == "LOADING_END" ) then
	elseif ( event == "SAVE_VARIABLES" ) then
		local point, relativePoint, relativeTo, x, y = this:GetAnchor()
		assert(Zifnabs_Settings, "[Zifnabs:SAVE_VARIABLES] Zifnabs_Settings variable is nil!" )
		Zifnabs_Settings.point = point
		Zifnabs_Settings.relativePoint = relativePoint
		Zifnabs_Settings.relativeTo = relativeTo:GetName()
		Zifnabs_Settings.offsetX = x
		Zifnabs_Settings.offsetY = y
		zif_echo("Einstellungen gespeichert")

	elseif ( event == "VARIABLES_LOADED" ) then
--		Zifnabs_Settings=nil										--RESET!!!
--		zif_echo("RESET!")										--RESET!!
		if not Zifnabs_Settings then
			Zifnabs_Settings={}
			Zifnabs_Settings=Zifnabs_DefaultSettings
			zif_echo("Default-Einstellungen geladen")
		else
			for item,value in pairs(Zifnabs_DefaultSettings) do
				if not Zifnabs_Settings[item] then
					zif_echo("Neue Einstellung "..item.." eingefügt")
					Zifnabs_Settings[item]=Zifnabs_DefaultSettings[item]
				end
			end

		end
		
		this:ClearAllAnchors()
		this:SetAnchor(Zifnabs_Settings.point, Zifnabs_Settings.relativePoint, Zifnabs_Settings.relativeTo, Zifnabs_Settings.offsetX, Zifnabs_Settings.offsetY)
	else
		zif_error("undefinierter Event "..event..", arg1="..arg1)
	end	
end

function Zifnabs_OnUpdate(this, elapsed)
	timer=timer+elapsed
	if not loaded then
		if Zifnabs_Settings then
			zif_echo("Einstellungen geladen")
			zif_display()
			loaded=1
			zif_Timer_set(15,"check1")
		end
	end
	if timer_action[1] then
		if timer>=timer_action[1]["timer"] then
			zif_Timer_execute(timer_action[1]["command"])
			table.remove(timer_action,1)
		end
	end
end

function zif_Timer_set(seconds,command)
	local time=timer+seconds
	local action={["timer"]=time,["command"]=command}
	local before=1
	for t=1,#timer_action,1 do
		if time<timer_action[t]["timer"] then 
			before=t
		end
	end
	table.insert(timer_action,before,action)
end

function zif_Timer_execute(command)
	local cmd,parm=zif_parse(command)
	if (cmd=="check1") then
		zif_echo("Und? Alles gut?")
	elseif (cmd=="remind") then
		zif_echo("|cffff0000!! >>>|cff00ffff"..parm.."|cffff0000<<<< !!|r")
	else
		zif_error("Undefinierter Timer-Befehl "..command)
	end
end

function zif_display()
	getglobal("Zifnabs_Title"):SetText("Zifnabs "..Zifnabs_release)
	for i=1,99,1 do
		if getglobal("Zifnabs_Button"..i) then
			getglobal("Zifnabs_Button"..i):Hide()
		end
	end
	for number,text in pairs(Zifnabs_Settings["button"]) do
		if getglobal("Zifnabs_Button"..number) then
			getglobal("Zifnabs_Button"..number):Show()
			getglobal("Zifnabs_Button"..number):SetText(text)
		else
			zif_echo("Button "..number.." für "..text.." nicht gefunden")
		end
	end
	Zifnabs_Settings["release"]=Zifnabs_release
	if (Zifnabs_Settings["reloadui"]==1) then
		getglobal("Zifnabs_ReloadUI"):Show()
	else
		getglobal("Zifnabs_ReloadUI"):Hide()
	end
	if Zifnabs_Settings["visible"]==1 then
		getglobal("Zifnabs"):Show()
	else
		getglobal("Zifnabs"):Hide()
	end
end

function zif_parse(text)
	local blank=string.find(text," ")
	local parm=""
	if blank then
		parm=string.sub(text,blank+1)
		text=string.lower(string.sub(text,1,blank-1))
	end
	return text,parm
end

function zif_echo(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cffe09000Zifnabs: |r"..text)
end
function zif_error(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Zifnabs: "..text.."|r")
end

function zif_button(number)
	if Zifnabs_Settings["button"][number] then
		zif_tell(Zifnabs_Settings["button"][number])
	else
		zif_error("Button "..number.." ist nicht definiert")
	end
end

function zif_tell(button)
	local tbl1={}
	local tbl2={}
	local message=""
	if (UnitExists("target")) then
		tbl1=Zifnabs_Settings["say"][button]["any"]
		if UnitIsPlayer("target") and UnitSex("target")==0 then
			tbl2=Zifnabs_Settings["say"][button]["male"]
		elseif UnitIsPlayer("target") and UnitSex("target")==1 then
			tbl2=Zifnabs_Settings["say"][button]["female"]
		end
	else
		tbl1=Zifnabs_Settings["say"][button]["notarget"]
	end
	local mi=math.random(#tbl1+#tbl2)
	if mi<=#tbl1 then
		message=tbl1[mi]
	else
		message=tbl2[mi-#tbl1]
	end
	if message then
		SendChatMessage(message, "SAY", 0);
	else
		zif_error("interner Fehler, keine Meldung generiert")
	end
end
